public class EnvironmentMonitor extends PeriodicEventHandler
{
	MainMission controllingMission;

	public EnvironmentMonitor(PriorityParameters priority,
	PeriodicParameters periodic,
	StorageParameters storage,
	String name,
	MainMission mainMission)
	{
		super(priority, periodic, storage, null);
		controllingMission = mainMission;
	}

	@Override
	public void handleAsyncEvent()
	{
		Console.println("Checking Environment");

		// read cabin pressure from sensors
		controllingMission.setCabinPressure(0);

		// read emergency Oxygen Levels
		controllingMission.setEmergencyOxygen(0);

		// read remaining fuel
		controllingMission.setFuelRemaining(0);

	}
}
